#include"OptionDialog.h"

// geisler@primus.baynet.de
// Sat May 23 14:51:46 MEST 1998

#ifndef _OPTIONDIALOG_CPP
#define _OPTIONDIALOG_CPP

OptionDialog::OptionDialog(QWidget *parent, const char *name)
     :QTabDialog(parent, name, true)
{
  pg_dialog = new pgdialog(this,"Postgres");
  addTab(pg_dialog,"Postgres");
  gb_dialog = new GlobalDialog(this,"Global");
  addTab(gb_dialog,"Global");
 
  setOKButton("OK");
  setCancelButton("Cancel");
  pg_dialog->show();
  gb_dialog->show();
  connect(this, SIGNAL(applyButtonPressed()), this, SLOT(ok_pressed()));
  connect(this, SIGNAL(cancelButtonPressed()), this, SLOT(quit()));
};

OptionDialog::~OptionDialog()
{
#ifdef DEBUG
cout << "destroy OptionDialog\n";
#endif
};

void OptionDialog::setData(struct PGdialog *PGdiag, struct GlDialog *GlobalDiag)
{
  pg_dialog->setData(PGdiag);
  gb_dialog->setData(GlobalDiag);
};

void OptionDialog::ok_pressed()
{
  pg_dialog->ok_pressed();
  gb_dialog->ok_pressed();
  delete this;
};

void OptionDialog::quit()
{
  delete pg_dialog;
  delete gb_dialog;
  delete this;
};

#include"OptionDialog.moc"

#endif
